#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <time.h>

typedef struct {
  double pADL;
  double pMARRY;
  double c1SEX;
  double c1DIST; /*int c1DIST0; int c1MARRY */
  double c2SEX;
  double c2DIST;
} Xplic;
		
typedef struct {
  double bh0;
  double bn0;
  double padl;
  double pmarry;
  double alpha;
  double cbeta;
  double csex;
  double cdist;
  double mu;
  double sigma;
  double var_xsi;
  double m_er;
} Theta;

unsigned long int gen_theta(double**,int);

void Li(double*,double,int);
void profit(double**,double**,int*);
int  NE_function(double*,double*,double**);
void LB_inc(double*,double*,int,int*);
  
/* Utilities */
double get_vec_max(double*,int);
int get_vec_max_index(double*,int);

void initialize_random_generator(unsigned long);
void finalize_random_generator();
void generate_gaussian_vector(double*,int,double,double);
void generate_multinomial_vector(double**,int,int,double*);

void V_function(Theta*,Xplic*,double**);
void L_function(double*,Theta*,Xplic*);

int Read_File(double**,char*,int,int);
int Write_File(double**,char*,int,int);

