#include "global.h"

inline void profit(double** V, double** profi, int* choice)
{
  int inc,t;
  double x;

  /* Case where no child enters - Equilibrium 1 */
  t = (V[0][0] > V[0][1]) ? 0 : 1;
  profi[0][0] = V[1][t]; /* profit child 1 */
  profi[0][1] = V[2][t]; /* profit child 2 */


  choice[0] = t; /* Option chosen by the family */

  /* Case where both child enter - Equilibrium 4 */
  x = V[0][0] + V[1][0] + V[2][0];
  t = 0;
  for(inc=1; inc<4; inc++) {
    if ((V[0][inc] + V[1][inc] + V[2][inc]) > x) {
      x = V[0][inc] + V[1][inc] + V[2][inc];
      t = inc;
    }
  }
  x /= 3.0;
  profi[3][0] = x; 
  profi[3][1] = x;
  choice[3] = t;

  /* Case where child2 enters - Equilibrium 2 */

  x = V[0][0] + V[2][0];
  t = 0;
  if ((V[0][1] + V[2][1]) > x) {
    x = V[0][1] + V[2][1]; 
    t = 1;
  }
  if ((V[0][3] + V[2][3]) > x) {
    x = V[0][3] + V[2][3];
    t = 3;
  }
  profi[1][0] = V[1][t];   /* Profit Child 1 */
  profi[1][1] = 0.5*x;     /* Profit Child 2 */

  choice[1] = t;

  /* Case where child1 enters - Equilibrium 3 */

  x = V[0][0] + V[1][0];
  t = 0;
  for(inc=1; inc<3; inc++) {
    if ((V[0][inc] + V[1][inc]) > x) {
      x = V[0][inc] + V[1][inc];
      t = inc;
    }
  }
  profi[2][0] = 0.5*x; 	     /* Profit Child 1 */
  profi[2][1] = V[2][t];     /* Profit Child 2 */

  choice[2] = t;
}

	


