#include "global.h"

const gsl_rng_type* T;
gsl_rng* rseed;

void initialize_random_generator(unsigned long s)
{
  gsl_rng_env_setup();
  T = gsl_rng_default;
  rseed = gsl_rng_alloc(T);
  gsl_rng_set(rseed,s);
}

void generate_gaussian_vector(double* x,int n,double mu,double sigma)
{
  int i;
  for(i=0; i<n; i++) {
    x[i] = mu + gsl_ran_gaussian_ziggurat(rseed,sigma);
  }
}

void generate_multinomial_vector(double** A,int N,int tr,double* p)
{
  int i,j;
  unsigned int ptr[tr];

  for(i=0; i<N; i++) {
    gsl_ran_multinomial(rseed,tr,1,p,ptr);
	
    for(j=0; j<tr; j++) {
      A[i][j] = ptr[j];
    }
  }
} 

void finalize_random_generator()
{
  gsl_rng_free(rseed);
}
