/* Utility functions for the program care*/
# include "global.h"

/*Return the maximum of a vector */
double get_vec_max(double* x,int n)
{ int i;
  double mvalue = x[0];
  for(i=1; i<n; i++) {
    if (x[i] > mvalue) mvalue = x[i];
  }
  return mvalue;
}

/* Return the index of the maximum*/
int get_vec_max_index(double* x,int n)
{ int i;
  double mvalue = x[0];
  int mindex = 0;
  for(i=1; i<n; i++) {
    if (x[i] > mvalue) {
      mvalue = x[i];
      mindex = i;
    }
  }
  return mindex;
}

/* To read a file*/
int Read_File(double** A,char* name,int N,int M)
{
  FILE *fp;
  unsigned long i,j;
  double x;
  unsigned long fileLen;

  /* Open file */
  fp = fopen(name,"r");
  if (!fp) {
    fprintf(stderr,"Unable to open file %s\n",name);
    return 1;
  }

  /*Get file length */
  fseek(fp,0,SEEK_END);
  fileLen = ftell(fp);
  fseek(fp,0,SEEK_SET);
  if (fileLen != sizeof(double)*N*M) {
    fprintf(stderr,"Size error for file %s\n",name);
    fclose(fp);
    return 2;
  }

  for(j=0; j<M; j++){
     for(i=0; i<N; i++) {
      fread((char*)(&x),sizeof(double),1,fp);
      A[i][j] = x;
    }
  }

  fclose(fp);
  return 0;
}

int Write_File(double** A,char* name,int N,int M)
{
  FILE *fp;
  unsigned long i,j;
  double x;
	
  /* Open file */
  fp = fopen(name,"w");
  if (!fp) {
    fprintf(stderr,"Unable to open file %s\n",name);
    return 1;
  }

  /* Write file contents into file */
  for(j=0; j<M; j++){
     for(i=0; i<N; i++) {
      x = A[i][j];
      fwrite((char*)&x,sizeof(double),1,fp);
    }
  }
  fclose(fp);
  return 0;
}	
