function [Adj_dec] = adjacency_dec(E)
% Used for simulations: ES_elder_care.
% From the adjacency matrix of a equilibrium correspondence, defines all the
% set Z^{cap}

% See example of supermodular game in HMQ.

%% Adjacency matrix for all the case alpha = c.

%1:OO
%2:OL
%3:LO
%4:HH OO
%5:HH OL
%6:HH HL
%7:OO LH
%8:OL LH
%9:LL LH
%10:HH HL OO
%11:HH HL LO
%12:LL OO LH
%13:HH LH OL
%14:HH LH OO
%15:HH HL LH LL
%16:HH LL OO LH HL

%0:OO
%1:OL
%2:LO
%3:LL
%4:HH
%5:OO LH
%6:OL LH
%7:LL OO
%9:LL LH
%10:HL OO
%11:HL LO
%12:HL LL
%13:HH OO
%14:HH OL
%15:HH LO
%16:HH LH
%17:HH HL
%18:LH LL OO
%19:HL LL OO
%20:HH LH OL
%21:HH LH OO
%22:HH HL OO
%23:HH HL LO
%24:HH HL LH LL
%25:HH LL OO LH HL
A = zeros(7,26);
%OO
A(1,[1 6 8 11 14 19 20 22 23 26]) = 1;
%OL
A(2,[2 7 15 21]) = 1;
%LO
A(3,[3 12 16 24]) = 1;
%LL
A(4,[4 8 10 13 19 20 25 26]) = 1;
%LH
A(5,[6 7 10 17 19 21 22 25 26]) = 1;
%HL
A(6,[11 12 13 18 20 23 24 25 26]) = 1;
%HH
A(7,[5 14 15 16 17 18 21 22 23 24 25 26]) = 1;

%% Building a secondary adjacency matrix to binifile
Adj_dec = zeros(length(E),length(A(1,:)));

for i = 1:length(E)
    Z = E(i,:)';
    Z = Z(:,ones(1,length(A(1,:))));
    Adj_dec(length(E)-i+1,:) = (sum(Z.*A,1)>0);
end

%binifile(Adj_dec, 'C:\cygwin\home\Romu\care_sim\adj_mat_dec.bin','double')