function [PHAT,G_n,W_b]=bootstrap_sim_x(Y,B,nb,x_eq)

% This procedure Compute first PHAT and then the sample paths of its
% empirical process by bootstrapping.

%% Compute PHAT

% Smoothed empirical mean
PHAT=n_param_mean(Y,x_eq,x_eq, nb);

%% Bootstrap replication of sample paths
% We use a bootstrap to determine B drawing of Gn.
%        G_n_b=G_n_b(m,:)=(PHAT_b(m,:)-PHAT(m,:))*sqrt(n*h_n)
% Then compute beta_m as the sup of (1-alpha)*B values of Gn.
% in inc_PHAT_sim_x

%% Initialization of scalars
n  = nb.obs;
dim= nb.option;
% Y_b = zeros(n,1);

%% Procedure Bootstrap pour estimer Gn_b
%Pour B tirages
W_b = zeros(B,1);
G_n = zeros(n,dim,B);
N = ones(n,1);
for b = 1:B
    
    % Tirer dans la distribution PHAT les Y_b  
    Y_b = mnrnd(N,PHAT)*(1:1:dim)';
%     for i=1:nb.obs
%         Y_b(i) = find(Ycase(i,:) == 1); % reindexing the equilibrium.
%     end
    
    % Empirical mean
    PHAT_b = n_param_mean(Y_b,x_eq,x_eq,nb);
    %-----------------------------------------------------------------
    % Computing Gn_b
    %-----------------------------------------------------------------
    G_n(:,:,b)=(PHAT_b-PHAT); 

    % From this point, the program is concerned by discarding B-B_flat
    % bootstrap drawing. we first maximize the criterion Wb
    G_n_plus=max(zeros(size(G_n(:,:,b))),G_n(:,:,b)); %maximum entre 0 et la valeur de G_n
    mw=sum(G_n_plus,2);
    W_b(b)=max(mw);

end

% %% Discarding the alpha*B higest values
% 
% %keep the (1-alpha)*B greater z
% %[keeper_m,IX]=sort(keeper(:,m),'descend');
% [keeper_m,IX]=sort(W_b,'ascend');
% keeper_m=[keeper_m IX];
% keeper_alpha_m=keeper_m(1:B_flat,:);
% 
% for inc=1:B_flat
%     G_n_garde(:,:,inc)=G_n(:,:,keeper_alpha_m(inc,2));
% end
% 
% for i=1:n
%     for j=1:dim
%         beta_m(i,j)=max(G_n_garde(i,j,:));
%     end
% end
