function [x_eq,x_ngb]=x_refd(X,grid)

%% Initialisation

nb.r_x  = length(X(:,1));
nb.dim_x= length(X(1,:));
prim_index = (1:1:nb.r_x)'; % Primitive index
 
l_grid = length(grid(:,1)); % grid contains all the pssible combination of Xplicatives
x_eq   = struct([]); % prim is a structure that keep the indices of different values of X
x_ngb  = struct([]);

%% Defining the same vectors and the neighbors

for giter=1:l_grid
    x_verif = grid(giter,:); % The vector for which we want to know the other occurences
    x_verif = x_verif(ones(nb.r_x,1),:); % Transform the vector in a matrix of the same size as X
    
    % Finding the same vectors in the matrix
    index_temp = sum (X==x_verif,2) == nb.dim_x; % Verify the equality of X and x_verif. We keep indexes of lines 
    Index = prim_index(index_temp==1,:); % 
    
    if isempty(Index)~=1
        x_eq(giter).Index =Index;
    elseif giter==l_grid
        x_eq(giter).Index =[];
    end
    
    % Finding the neighbors
    index_temp = (sum (X==x_verif,2) == nb.dim_x-1) & (X(:,nb.dim_x)==x_verif(:,nb.dim_x));
    Index = prim_index(index_temp==1,:);
    
    if isempty(Index)~=1
        x_ngb(giter).Index =Index;
    elseif giter==l_grid
        x_ngb(giter).Index =[];
    end

end


